/*
   Copyright 2000, 2001, 2002, 2003 Laurent Wacrenier

   This file is part of PLL lmtpd.

   PLL lmtpd is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   PLL lmtpd is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with PLL lmtpd; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

/* $Id: re.h,v 1.9 2004/03/24 15:33:07 lwa Exp $ */

#ifndef _RE_RE_H_
#define _RE_RE_H_

#define RE_MATCH    0
#define RE_NOTMATCH 1

#define RE_ERR_NOERR   0
#define RE_ERR_MEMORY  1
#define RE_ERR_SYNTAX  2

typedef struct _re {
  int          (*compile)(struct _re *re, char *pattern, int icase);
  int          (*exec)(struct _re *re, char *string);
  void         (*close)(struct _re *re);
  int options;
  int err;
  const char *errstr;
  void *code;
  void *hint; /* for pcre */
} RE;

char *re_init(void);
RE *re_new(char *pattern, char *type);
RE *re_find(char **source);

char *re_cache_init(void);
void re_cache_flush(int n);

RE *re_cache_search(RE *re, char *source, char *source_end, 
		    char *pattern, char *pattern_end, int icase);

#endif
